import { Deserialize } from './de'
import { Serialize } from './ser'

export class Registry {
  serializers: Map<Function, Serialize<any, any>> = new Map()
  deserializers: Map<Function, Deserialize<any>> = new Map()

  registerSerialize<T, U>(ctor: Function, serialize: Serialize<T, U>) {
    this.serializers.set(ctor, serialize)
  }

  registerDeserialize<T>(ctor: Function, deserialize: Deserialize<T>) {
    this.deserializers.set(ctor, deserialize)
  }
}

export const GlobalRegistry = new Registry()
export const registerSerialize = GlobalRegistry.registerSerialize.bind(GlobalRegistry)
export const registerDeserialize = GlobalRegistry.registerDeserialize.bind(GlobalRegistry)

